;------------------------------------------------------
; Sol_Asm assembler core
; Copyright (c) 2004-2005, Bogdan Valentin Ontanu.
; All rights reserved.
;------------------------------------------------------


;=======================================;
; Encode Call(s)
;=======================================


;==============================
;Call to label
;==============================
Encode_CALL_Label PROC
	USES	ebx,esi,edi
	ARG	@@call_here:dword


	ODS1	<"+++Encode Call Label">

	mov	edi,[out_crt]
	add	edi,[lp_out_buff]

	;--------------------------
	; write opcode
	;--------------------------
	mov	al,0E8h
	mov	byte ptr [edi],al

	inc	edi
	inc	[out_crt]	
	inc	[addr_crt]

	;-----------------------
	; calc displacement
	;-----------------------
	mov	ebx,[addr_crt]
	add	ebx,4	
	mov	eax,[@@call_here]
	sub	eax,ebx

	ODS1	<"Call Displacement:">
	ODV	eax

	mov	dword ptr [edi],eax
	
	add	[addr_crt],4
	add	[out_crt],4	

	ret
ENDP

;==============================
;Call a Procedure
;==============================
Encode_CALL_Proc PROC
	USES	ebx,esi,edi
	ARG	@@call_here:dword


	ODS1	<"+++Encode Call PROC">

	mov	edi,[out_crt]
	add	edi,[lp_out_buff]

	;--------------------------
	; write opcode
	;--------------------------
	mov	al,0E8h
	mov	byte ptr [edi],al

	inc	edi
	inc	[out_crt]	
	inc	[addr_crt]

	;-----------------------
	; calc displacement
	;-----------------------
	mov	ebx,[addr_crt]
	add	ebx,4	
	mov	eax,[@@call_here]
	sub	eax,ebx

	ODS1	<"Call Displacement:">
	ODV	eax

	mov	dword ptr [edi],eax
	
	add	[addr_crt],4
	add	[out_crt],4	

	ret
ENDP

;================================
; Call eax
;================================
Encode_CALL_Reg PROC
	USES	ebx,esi,edi
	ARG	@@register:dword

	ODS1	<"+++Encode Call Register">

	mov	edi,[out_crt]
	add	edi,[lp_out_buff]

	;--------------------------
	; write opcode
	;--------------------------
	mov	al,0FFh
	mov	byte ptr [edi],al

	inc	edi
	inc	[out_crt]	
	inc	[addr_crt]

	;-----------------------
	; calc register
	;-----------------------
	mov	eax,[@@register]
	or	eax,11010000b		;Mod=11, ext=100,M/R=reg
	mov	byte ptr [edi],al

	add	[addr_crt],1
	add	[out_crt],1	

	ret
ENDP
