;------------------------------------------------------
; Sol_Asm assembler core
; Copyright (c) 2004-2005, Bogdan Valentin Ontanu.
; All rights reserved.
;------------------------------------------------------

;************************************
; Encode RET/RETN Instructions
;************************************


;======================
;Encode Ret for PROC's
;======================
Encode_RET PROC
	USES	edi

	mov	edi,[lp_out_buff]
	add	edi,[out_crt]

	mov	al,0C3h
	mov	byte ptr [edi],al

	add	[out_crt],1
	add	[addr_crt],1

	ret
ENDP

;======================
;Encode RetN for PROC's
;======================
Encode_RETN PROC
	USES	edi
	ARG	@@param_n:dword

	mov	edi,[lp_out_buff]
	add	edi,[out_crt]

	;-----------------------
	; write opcode
	;-----------------------
	mov	al,0C2h
	mov	byte ptr [edi],al

	inc	edi
	add	[out_crt],1
	add	[addr_crt],1
	;-----------------------
	;encode N
	;-----------------------
	mov	eax,[@@param_n]
	mov	word ptr [edi],ax

	add	[out_crt],2
	add	[addr_crt],2

	ret
ENDP


;===============================
;RetN stuff
;===============================


On_Mode_RETN PROC
	USES	esi,edi
	ARG 	@@token_start,@@token_size:dword

	ODS1	<"On Mode RETN">

	;---------------------------------
	;convert to number, result in eax
	;---------------------------------
	Call	Check_Value,[@@token_start],[@@token_size]
	.IF eax==-1
		;-------------------------------------
		; Not A Number
		;-------------------------------------			
		Call	Print_Error,offset sz_err_010,[@@token_start],[@@token_size]
	.ELSE
		.IF ebx>65535
			Call	Print_Error,offset sz_err_003,[@@token_start],[@@token_size]
		.ENDIF

		;-------------------------
		;encode RETn
		;-------------------------
		mov	edi,[lp_out_buff]
		add	edi,[out_crt]
		mov	al,0C2h
		mov	byte ptr [edi],al

		inc	edi
		add	[out_crt],1
		add	[addr_crt],1
		;-----------------------
		;encode N
		;-----------------------
		mov	eax,ebx
		mov	word ptr [edi],ax

		add	[out_crt],2
		add	[addr_crt],2
	.ENDIF

	mov	[parse_mode],P2_MODE_DEFAULT	
	ret

ENDP
