;------------------------------------------------------
; Sol_Asm assembler core
; Copyright (c) 2004-2005, Bogdan Valentin Ontanu.
; All rights reserved.
;------------------------------------------------------

;=================================
; Structure Members ;)
;=================================

;----------------------------
; Structure members
;----------------------------
SMEM_STRU STRUC
	smem_name	db	128 dup(?)
	smem_name_len	dd	?
	smem_next	dd	?
	smem_size	dd	?

	smem_offset	dd	?
	smem_segment	dd	?
ENDS

SMEM_MAX	EQU	128*1024
SMEM_HASH_MAX	EQU	65538
SMEM_HASH_MASK	EQU	0FFFFh

.data
	smem_count	dd	-1
	smem_crt	dd	-1
.data?
	
	smem_base0	SMEM_STRU	SMEM_MAX 	dup (<?>)
	smem_hash0	dd		65538		dup(?)
.code



Clear_Hash_Stru_Members PROC
	USES	ecx,edi

	ODS1	<"+++Clear Structures Members Hash">

	mov	edi,offset smem_hash0
	mov	ecx,65537
	mov	eax,-1

@@loop_clear:
	mov	[edi],eax
	add	edi,4
	dec	ecx
	jnz	@@loop_clear

	ret
ENDP



;Create_Stru_Member PROTO :dword, :dword
Create_Stru_Member PROC
	USES	esi,edi
	ARG 	@@token_start,@@token_size:dword


	ODS1	<"+++Create Structure Member">

	Call	Str_Copy_Nr,[@@token_start],offset sz_tmp1,[@@token_size]
	ODS	<offset sz_tmp1>

	mov	eax,[smem_count]
	inc	eax
	mov	[smem_count],eax

	cmp	eax,SMEM_MAX
	jc	@@stru_ok

	dec	eax
	mov	[smem_count],eax
	;------------------------------------------------
	; Error: can not create more stru members's, :(
	; Todo: make this dynamic?
	;------------------------------------------------
	Call	Print_Error,offset sz_err_037,[@@token_start],[@@token_size]
	mov	eax,-1
	ret

@@stru_ok:
	;--------------------------------
	; we are in this smem body
	;--------------------------------
	mov	[smem_crt],eax

	;------------------------------
	;calculate the structure address
	;------------------------------
	mov	esi,offset smem_base0
	mov	ebx,SIZE SMEM_STRU
	mul	ebx
	add	esi,eax

	;------------------------------
	;fill stru name in
	;------------------------------
	push	esi
		add	esi,smem_name
		Call	Str_Copy_Nr,[@@token_start],esi,[@@token_size]
	pop	esi

	;---------------------------------
	;also name size
	;---------------------------------
	mov	eax,[@@token_size]
	mov	[esi.smem_name_len],eax

	xor	eax,eax
	mov	[esi.stru_offset],eax
	mov	[esi.stru_segment],eax

	;--------------------------------
	;make hash value
	;--------------------------------
	push	esi
	mov	edi,[@@token_start]
	mov	esi,[@@token_size]
	Call	Make_Hash
	pop	esi
	
	ODVh	 ebx
	;-----------------------
	; ebx=hash
	;-----------------------
	shl	ebx,2
	mov	edi,offset smem_hash0
	add	edi,ebx
	mov	eax,[edi]

	.IF eax==-1
		;-----------------------
		;empty hash location
		;-----------------------
		ODS1	<"Stru member:Add on empty hash">
		mov	ebx,[smem_count]
		mov	[edi],ebx
		mov	[esi.smem_next],eax
	.ELSE
		;------------------------
		;colision, eax=old guy
		;------------------------
		ODS1	<"Stru member:Add collission hash">
		mov	ebx,[smem_count]
		mov	[edi],ebx
		mov	[esi.smem_next],eax

	.ENDIF


	mov	eax,esi
	ret
ENDP


;====================================
; Verify if this Structure exists
;====================================
align 4
Check_Stru_Member PROC
	USES	esi,edi
	ARG	@@token_start,@@token_size:dword

	LOCAL	@@id_crt:dword

	ODS1	<"+++Check Structure Member via Hash">

	Call	Str_Copy_Nr,[@@token_start],offset sz_tmp1,[@@token_size]
	ODS	<offset sz_tmp1>
	ODV	[@@token_size]

;	mov		eax,-1
;	ret

	mov	ecx,[smem_count]
	cmp	ecx,-1
	jz	@@no_struc_members

	;--------------------------------
	;make hash value
	;--------------------------------
	push	esi
	mov	edi,[@@token_start]
	mov	esi,[@@token_size]
	Call	Make_Hash
	pop	esi
	;-----------------------
	; ebx=hash
	;-----------------------
	ODVh	ebx

	shl	ebx,2
	mov	edi,offset stru_hash0
	add	edi,ebx
	mov	eax,[edi]

	ODS1	<"ID at hash:">
	ODV	eax

	.IF eax==-1
		;-----------------------
		;empty hash location
		;-----------------------
		ODS1	<"Struc member Not found, empty hash">
		mov	eax,-1
		ret
	.ELSE
		;------------------------------------
		;hash hit, we have to check extra
		;------------------------------------
		ODS1	<"Struc member:Hash Hit">

	@@follow_link:
		ODS1	<"ID tested:">
		ODV	eax

		mov	[@@id_crt],eax

		mov	ebx, SIZE SMEM_STRU
		mul	ebx
		mov	edi,offset smem_base0
		add	edi,eax

		mov	eax,[edi.smem_name_len]
		cmp	eax,[@@token_size]
		jnz	@@next_link

		ODS1	<"Stru Member Name Length is Equal">

		push	edi

		mov	esi,[@@token_start]
		add	edi,smem_name		
		mov	ecx,[@@token_size]

		@@loop_cmp:
			mov	al,byte ptr [esi]
			mov	bl,byte ptr [edi]
			cmp	al,bl
			jnz	@@no_match

			inc	edi
			inc	esi

			dec	ecx
			jnz	@@loop_cmp

			ODS1	<"Structure Found">

			pop	edi
			mov	eax,[edi.smem_size]	; length
			mov	ebx,[edi.smem_size]	;decide later what to return here
			mov	ecx,[@@id_crt]		;id/handle of crt structure member
			ret			

		@@no_match:
			ODS1	<"Stru member:Char not match">
			
			pop	edi

		@@next_link:
			mov	eax,[edi.smem_next]
			
			cmp	eax,-1
			jnz	@@follow_link	
			
			mov	eax,-1
			ret
	.ENDIF

@@no_struc_members:
	mov	eax,-1
	ret
ENDP



;=================================
; Util function
;=================================
.data
	sz_info_mem	db	13,10,"Printing STRUCT's:",13,10
					db	"-----------------------------",0

	sz_info_smem2	db	13,10
					db	"-----------------------------",13,10,0

	sz_fmt_smem		db	13,10,"[%i]%s",09,"Addr:%i",0
.code
Print_Stru_Members PROC
	USES	esi,edi
	LOCAL	@@tmp_cnt:dword

	ODS1	<"+++Print Struc Members">

	.IF [stru_count]==-1
		ret
	.ENDIF

	Call	Print_Text,offset sz_info_stru

	mov	[@@tmp_cnt],0
	mov	esi,offset stru_base0
	mov	ecx,[stru_count]
	cmp	ecx,-1
	jz	@@end_strucs

	inc	ecx

@@loop_strucs:
	push	ecx
	push	esi
	
	mov	eax,[esi.stru_name_len]
	Call	Str_Copy_Nr,esi,offset sz_tmp1,eax

	mov	eax,[esi.stru_offset]
	Call	wsprintfA,offset sz_tmp2,offset sz_fmt_stru,[@@tmp_cnt],offset sz_tmp1,eax
	Call	Print_Text,offset sz_tmp2

	pop	esi
	pop	ecx
	;------------------
	; next structure
	;------------------
	inc	[@@tmp_cnt]
	add	esi,SIZE STRU_STRU
	dec	ecx
	jnz	@@loop_strucs

@@end_strucs:
	Call	Print_Text,offset sz_info_stru2

	ret
ENDP
