;------------------------------------------------------
; Sol_Asm assembler core
; Copyright (c) 2004-2005, Bogdan Valentin Ontanu.
; All rights reserved.
;------------------------------------------------------

;=================================
; Structures
;=================================

;----------------------------
; funny name
; :P confusing isnt it?
;----------------------------
STRU_STRU STRUC
	stru_name		db	128 dup(?)
	stru_name_len	dd	?
	stru_next		dd	?

	stru_size		dd	?

	stru_offset		dd	?
	stru_segment	dd	?
ENDS

STRU_MAX		EQU	128*1024
STRU_HASH_MAX	EQU	65538
STRU_HASH_MASK	EQU	0FFFFh

.data
	stru_count	dd	-1
	stru_crt	dd	-1
.data?
	
	stru_base0	STRU_STRU	STRU_MAX dup (<?>)
	stru_hash0	dd		65538	dup(?)
.code



Clear_Hash_Structure PROC
	USES	ecx,edi

	ODS1	<"+++Clear Hash Structures">

	mov	edi,offset stru_hash0
	mov	ecx,65537
	mov	eax,-1

@@loop_clear:
	mov	[edi],eax
	add	edi,4
	dec	ecx
	jnz	@@loop_clear

	ret
ENDP



;Create_Structure PROTO :dword, :dword, :dword
Create_Structure PROC
	USES	esi,edi
	ARG 	@@token_start,@@token_size:dword
	ARG		@@stru_offset:dword

	ODS1	<"+++Create Structure">

	Call	Str_Copy_Nr,[@@token_start],offset sz_tmp1,[@@token_size]
	ODS		<offset sz_tmp1>

	mov	eax,[stru_count]
	inc	eax
	mov	[stru_count],eax

	cmp	eax,STRU_MAX
	jc	@@stru_ok

	dec	eax
	mov	[stru_count],eax
	;------------------------------------------------
	; Error: can not create more structures's, :(
	; fixme: make this dynamic?
	;------------------------------------------------
	Call	Print_Error,offset sz_err_033,[@@token_start],[@@token_size]
	mov	eax,-1
	ret

@@stru_ok:
	;--------------------------------
	; we are in this structure body
	;--------------------------------
	mov	[stru_crt],eax
	;------------------------------
	;calculate the structure address
	;------------------------------
	mov	esi,offset stru_base0
	mov	ebx,SIZE STRU_STRU
	mul	ebx
	add	esi,eax

	;------------------------------
	;fill stru name in
	;------------------------------
	push	esi
		add	esi,stru_name
		Call	Str_Copy_Nr,[@@token_start],esi,[@@token_size]
	pop	esi

	;---------------------------------
	;also name size
	;---------------------------------
	mov	eax,[@@token_size]
	mov	[esi.stru_name_len],eax

	xor	eax,eax
	mov	[esi.stru_size],eax
	mov	[esi.stru_offset],eax
	mov	[esi.stru_segment],eax

	;--------------------------------
	;make hash value
	;--------------------------------
	push	esi

	mov	edi,[@@token_start]
	mov	esi,[@@token_size]
	Call	Make_Hash
	pop	esi
	
	ODVh	 ebx
	;-----------------------
	; ebx=hash
	;-----------------------
	shl	ebx,2
	mov	edi,offset stru_hash0
	add	edi,ebx
	mov	eax,[edi]

	.IF eax==-1
		;-----------------------
		;empty hash location
		;-----------------------
		ODS1	<"Stru:Add on empty hash">
		mov		ebx,[stru_count]
		mov		[edi],ebx

		mov		[esi.stru_next],eax
	.ELSE
		;------------------------
		;colision, eax=old guy
		;------------------------
		ODS1	<"Stru:Add collission hash">
		mov		ebx,[stru_count]
		mov		[edi],ebx

		mov		[esi.stru_next],eax

	.ENDIF


	mov	eax,esi
	ret
ENDP


;====================================
; Verify if this Structure exists
;====================================
align 4
Check_Structure PROC
	USES	esi,edi
	ARG	@@token_start,@@token_size:dword

	LOCAL	@@id_crt:dword

	ODS1	<"+++Check Structure via Hash">

	Call	Str_Copy_Nr,[@@token_start],offset sz_tmp1,[@@token_size]
	ODS	<offset sz_tmp1>
	ODV	[@@token_size]

;	mov	eax,-1
;	ret

	mov	ecx,[stru_count]
	cmp	ecx,-1
	jz	@@no_strucs

	;--------------------------------
	;make hash value
	;--------------------------------
	push	esi
	mov	edi,[@@token_start]
	mov	esi,[@@token_size]
	Call	Make_Hash
	pop	esi
	;-----------------------
	; ebx=hash
	;-----------------------
	ODVh	ebx

	shl	ebx,2
	mov	edi,offset stru_hash0
	add	edi,ebx
	mov	eax,[edi]

	ODS1	<"ID at hash:">
	ODV	eax

	.IF eax==-1
		;-----------------------
		;empty hash location
		;-----------------------
		ODS1	<"Struc Not found, empty hash">
		mov	eax,-1
		ret
	.ELSE
		;------------------------------------
		;hash hit, we have to check extra
		;------------------------------------
		ODS1	<"Struc:Hash Hit">

	@@follow_link:
		ODS1	<"ID tested:">
		ODV	eax

		mov	[@@id_crt],eax

		mov	ebx, SIZE STRU_STRU
		mul	ebx
		mov	edi,offset stru_base0
		add	edi,eax

		mov	eax,[edi.stru_name_len]
		cmp	eax,[@@token_size]
		jnz	@@next_link

		ODS1	<"Stru Name Length is Equal">

		push	edi

		mov	esi,[@@token_start]
		add	edi,stru_name		
		mov	ecx,[@@token_size]

		@@loop_cmp:
			mov	al,byte ptr [esi]
			mov	bl,byte ptr [edi]
			cmp	al,bl
			jnz	@@no_match

			inc	edi
			inc	esi

			dec	ecx
			jnz	@@loop_cmp

			ODS1	<"Structure Found">

			pop	edi
			mov	eax,[edi.stru_size]	;sum of members length
			mov	ebx,[edi.stru_size]	;decide later what to return here
			mov	ecx,[@@id_crt]		;id/handle of crt structure
			ret			

		@@no_match:
			ODS1	<"Stru:Char not match">
			
			pop	edi

		@@next_link:
			mov	eax,[edi.stru_next]
			
			cmp	eax,-1
			jnz	@@follow_link	
			
			mov	eax,-1
			ret
	.ENDIF

@@no_strucs:
	mov	eax,-1
	ret
ENDP



;=================================
; Util function
;=================================
.data
	sz_info_stru	db	13,10,"Printing STRUCT's:",13,10
					db	"-----------------------------",0

	sz_info_stru2	db	13,10
					db	"-----------------------------",13,10,0

	sz_fmt_stru		db	13,10,"[%i]%s",09,"Addr:%i",0
.code
Print_Structures PROC
	USES	esi,edi
	LOCAL	@@tmp_cnt:dword

	ODS1	<"+++Print Structures">

	.IF [stru_count]==-1
		ret
	.ENDIF

	Call	Print_Text,offset sz_info_stru

	mov	[@@tmp_cnt],0
	mov	esi,offset stru_base0
	mov	ecx,[stru_count]
	cmp	ecx,-1
	jz	@@end_strucs

	inc	ecx

@@loop_strucs:
	push	ecx
	push	esi
	
	mov	eax,[esi.stru_name_len]
	Call	Str_Copy_Nr,esi,offset sz_tmp1,eax

	mov	eax,[esi.stru_offset]
	Call	wsprintfA,offset sz_tmp2,offset sz_fmt_stru,[@@tmp_cnt],offset sz_tmp1,eax
	Call	Print_Text,offset sz_tmp2

	pop	esi
	pop	ecx
	;------------------
	; next structure
	;------------------
	inc	[@@tmp_cnt]
	add	esi,SIZE STRU_STRU
	dec	ecx
	jnz	@@loop_strucs

@@end_strucs:
	Call	Print_Text,offset sz_info_stru2

	ret
ENDP
