;------------------------------------------------------
; Sol_Asm assembler interface to win32api
; Copyright (c) 2004-2005, Bogdan Valentin Ontanu.
; All rights reserved.
;------------------------------------------------------

;****************************************
; the only functions used from win32api
;****************************************
extrn	GetCommandLineA:PROC
extrn	GetStdHandle:PROC

STD_INPUT_HANDLE		equ -10
STD_OUTPUT_HANDLE		equ -11
STD_ERROR_HANDLE		equ -12

extrn	GetModuleHandleA:PROC
extrn	GetTickCount:PROC
extrn	ExitProcess:PROC
extrn	ReadConsoleA:PROC
extrn	WriteConsoleA:PROC

wsprintfA PROTO C :DWORD:?


;---------------------------------------------
; PC info stuff
;---------------------------------------------
extrn	GetLocalTime:PROC
extrn	GetLastError:PROC

extrn	QueryPerformanceCounter:PROC
extrn	QueryPerformanceFrequency:PROC

;-----------------------------------------
; Memory management related stuff
;-----------------------------------------
extrn	GlobalAlloc:PROC
extrn	GlobalFree:PROC
extrn	GlobalSize:PROC

extrn	GlobalLock:PROC
extrn	GlobalUnlock:PROC


GMEM_FIXED	EQU	0000h
GMEM_MOVEABLE	EQU	0002h
GMEM_ZEROINIT	EQU	0040h
GMEM_FIXED	EQU	0000h
GHND		EQU	GMEM_MOVEABLE + GMEM_ZEROINIT
GPTR		EQU	GMEM_FIXED + GMEM_ZEROINIT

extern	OutputDebugStringA:PROC

extrn	Sleep:PROC


;==========================================
; READ\WRITE FILE
;==========================================
extrn		WriteFile:Proc
extrn		CloseHandle:Proc
extrn		SetFilePointer:Proc
extrn		CreateFileA:Proc
extrn		ReadFile:Proc
extrn		GetFileSize:PROC
extrn		FlushFileBuffers:PROC

;----------------------------------------------
; CreateFileA parameters
;----------------------------------------------
;param dwCreationDistribution
	CREATE_NEW				equ 1
	CREATE_ALWAYS				equ 2
	OPEN_EXISTING				equ 3
	OPEN_ALWAYS				equ 4
	TRUNCATE_EXISTING			equ 5
;sharemode
;	0	not shared
;file attrib and flags
;atrib
	FILE_ATTRIBUTE_READONLY			equ 1h
	FILE_ATTRIBUTE_HIDDEN			equ 2h
	FILE_ATTRIBUTE_SYSTEM			equ 4h
	FILE_ATTRIBUTE_DIRECTORY		equ 10h
	FILE_ATTRIBUTE_ARCHIVE			equ 20h
	FILE_ATTRIBUTE_NORMAL			equ 80h
	FILE_ATTRIBUTE_TEMPORARY		equ 100h
	FILE_ATTRIBUTE_COMPRESSED		equ 800h
;flags
	FILE_FLAG_WRITE_THROUGH			equ 80000000h
	FILE_FLAG_OVERLAPPED			equ 40000000h
	FILE_FLAG_NO_BUFFERING			equ 20000000h
	FILE_FLAG_RANDOM_ACCESS			equ 10000000h
	FILE_FLAG_SEQUENTIAL_SCAN		equ 08000000h
	FILE_FLAG_DELETE_ON_CLOSE		equ 04000000h
	FILE_FLAG_BACKUP_SEMANTICS		equ 02000000h
	FILE_FLAG_POSIX_SEMANTICS		equ 01000000h
;desired access
	GENERIC_READ				equ 80000000h
	GENERIC_WRITE				equ 40000000h
;--------------------------------------------------
;=========PARAM. SetFilePointer==============
	FILE_BEGIN			equ 0
	FILE_CURRENT			equ 1
	FILE_END			equ 2
;============================================


